#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/mman.h>
#include "filtere.c"
#define FRAMESIZE 1302528
#define plot(x,y,c) (ColorStart[(x)+1152*(y)]=(c))  
#define get(x,y)    ColorStart[(x)+1152*(y)]

typedef unsigned char byte;
extern char * mmap();
byte *MaskStart;
byte *ColorStart;
byte *BwStart;


/*************** Stjaalet meget elegant fra Tegge *********/
void initgraph() 
{ 
  byte *Tabell;
  int fd;
  if ((fd=open("/dev/cgfour0",2))<0) 
    {
      (void) printf("\nEg kunne ikkje opne fargeskjermen\n"); 
      exit(4);
    } 
  Tabell=(byte *) 
    mmap((caddr_t)0,FRAMESIZE,PROT_READ|PROT_WRITE,MAP_SHARED,fd,(off_t)0);
  ColorStart=&Tabell[262144];MaskStart=&Tabell[131072];BwStart=Tabell;
}

void gjoer_det()
{
  int minx=250,miny=250,maxx=0,maxy=0;
  int tx,ty,teller;
  int dx,dy;
  byte basis;
  char *data;
  
  data=malloc((unsigned)250*250);
  basis=get(0,0);
  for(ty=0;ty<250;ty++)
    for(tx=0;tx<250;tx++)
      if(get(tx,ty)!=basis)
	{
	  if (tx>maxx) maxx=tx;
	  if (tx<minx) minx=tx;
	  if (ty>maxy) maxy=ty;
	  if (ty<miny) miny=ty;
	}
  if ((maxx==249)||(maxy==249))
    {
      fprintf(stderr,"Bildet gaar utenfor rammene\n");
      exit(1);
    }
  teller=0;
  for(ty=miny;ty<=maxy;ty++)
    for(tx=minx;tx<=maxx;tx++)
      if(get(tx,ty)==basis)
	data[teller++]=0;
      else
	data[teller++]=1;

  dx=maxx-minx+1;
  dy=maxy-miny+1;
  save(stdout,data,dx,dy,RLK|EGENGETPUT);
}


void main()
{
  initgraph();
  gjoer_det();
}
